OGRE-Next: Ogre::v1::VulkanHardwareBufferManagerBase Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::v1::VulkanHardwareBufferManagerBase Class Referencefinal

`#include <OgreVulkanHardwareBufferManager.h>`

Inheritance diagram for Ogre::v1::VulkanHardwareBufferManagerBase:
[legend]

## Public Member Functions
| VulkanHardwareBufferManagerBase (VulkanDevice *device, VaoManager *vaoManager)
| ~VulkanHardwareBufferManagerBase () override
VulkanDiscardBufferManager * | _getDiscardBufferManager ()
void | _notifyDeviceStalled ()
HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer) override
| Create a hardware index buffer.
HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer) override
| Create a hardware vertex buffer.
Public Member Functions inherited from Ogre::v1::HardwareBufferManagerBase
| HardwareBufferManagerBase ()
virtual | ~HardwareBufferManagerBase ()
virtual void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
virtual void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
virtual void | _freeUnusedBufferCopies ()
| Free all unused vertex buffer copies.
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
| Notification that a hardware index buffer has been destroyed.
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed.
virtual void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.
virtual HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer.
virtual VertexBufferBinding * | createVertexBufferBinding ()
| Creates a new VertexBufferBinding.
virtual VertexDeclaration * | createVertexDeclaration ()
| Creates a new vertex declaration.
virtual void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding.
virtual void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration.
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
| Registers a vertex buffer as a copy of another.
virtual void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use.
virtual void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse.

## Additional Inherited Members
Public Types inherited from Ogre::v1::HardwareBufferManagerBase
enum | BufferLicenseType { BLT_MANUAL_RELEASE , BLT_AUTOMATIC_RELEASE }

## Constructor & Destructor Documentation

## ◆ VulkanHardwareBufferManagerBase()

Ogre::v1::VulkanHardwareBufferManagerBase::VulkanHardwareBufferManagerBase | ( | VulkanDevice * | device,
|  | VaoManager * | vaoManager )

## ◆ ~VulkanHardwareBufferManagerBase()

Ogre::v1::VulkanHardwareBufferManagerBase::~VulkanHardwareBufferManagerBase | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getDiscardBufferManager()

VulkanDiscardBufferManager * Ogre::v1::VulkanHardwareBufferManagerBase::_getDiscardBufferManager | ( |  | ) |
| inline

## ◆ _notifyDeviceStalled()

void Ogre::v1::VulkanHardwareBufferManagerBase::_notifyDeviceStalled | ( |  | ) |

## ◆ createIndexBuffer()

HardwareIndexBufferSharedPtr Ogre::v1::VulkanHardwareBufferManagerBase::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer )
| overridevirtual

Create a hardware index buffer.

Remarks
  Note that because buffers can be shared, they are reference counted so you do not need to worry about destroying them this will be done automatically.

Parameters

  itype | The type in index, either 16- or 32-bit, depending on how many vertices you need to be able to address
  numIndexes | The number of indexes in the buffer
  usage | One or more members of the HardwareBuffer::Usage enumeration.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU or AGP memory. You should set this flag if you intend to read data back from the index buffer, because reading data from a buffer in the GPU or AGP memory is very expensive, and is in fact impossible if you specify HBU_WRITE_ONLY for the main buffer. If you use this option, all reads and writes will be done to the shadow buffer, and the shadow buffer will be synchronised with the real buffer at an appropriate time.

Implements Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::HardwareIndexBufferSharedPtr.

## ◆ createVertexBuffer()

HardwareVertexBufferSharedPtr Ogre::v1::VulkanHardwareBufferManagerBase::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer )
| overridevirtual

Create a hardware vertex buffer.

Remarks
  This method creates a new vertex buffer; this will act as a source of geometry data for rendering objects. Note that because the meaning of the contents of the vertex buffer depends on the usage, this method does not specify a vertex format; the user of this buffer can actually insert whatever data they wish, in any format. However, in order to use this with a RenderOperation, the data in this vertex buffer will have to be associated with a semantic element of the rendering pipeline, e.g. a position, or texture coordinates. This is done using the VertexDeclaration class, which itself contains VertexElement structures referring to the source data.
  Note that because vertex buffers can be shared, they are reference counted so you do not need to worry about destroying themm this will be done automatically.

Parameters

  vertexSize | The size in bytes of each vertex in this buffer; you must calculate this based on the kind of data you expect to populate this buffer with.
  numVerts | The number of vertices in this buffer.
  usage | One or more members of the HardwareBuffer::Usage enumeration; you are strongly advised to use HBU_STATIC_WRITE_ONLY wherever possible, if you need to update regularly, consider HBU_DYNAMIC_WRITE_ONLY and useShadowBuffer=true.
  useShadowBuffer | If set to `true`, this buffer will be 'shadowed' by one stored in system memory rather than GPU or AGP memory. You should set this flag if you intend to read data back from the vertex buffer, because reading data from a buffer in the GPU or AGP memory is very expensive, and is in fact impossible if you specify HBU_WRITE_ONLY for the main buffer. If you use this option, all reads and writes will be done to the shadow buffer, and the shadow buffer will be synchronised with the real buffer at an appropriate time.

Implements Ogre::v1::HardwareBufferManagerBase.

References Ogre::v1::HardwareBufferManagerBase::HardwareVertexBufferSharedPtr.

The documentation for this class was generated from the following file:

- OgreVulkanHardwareBufferManager.h